<script setup lang="ts">
import { computed, onMounted, reactive } from 'vue'
import FormStepper from '@/components/FormStepper.vue'
import Preview from '@/components/Preview.vue'
import FileUpload from '@/components/ProfilePictureUpload.vue'
import { onBeforeRouteLeave, useRouter } from 'vue-router'
import { useMyDataStore } from '@/stores/my-data'
import AppButton from '@/components/ui/AppButton.vue'
import ImageCropper from '@/components/ImageCropper.vue'
import type { ProfilePictureMetaFrameSpecs, UploadStatus } from '@/scripts/api-helper'
import { useAppStore } from '@/stores/app'

const router = useRouter()
const app = useAppStore()
const myData = useMyDataStore()

const state = reactive({
  lastProfilePictureStatus: null as UploadStatus | null,
  preferredFirstname: '',
  preferredLastname: '',
  loading: false,
  timeoutHandle: null as number | null,
  profilePictureUrl: null as string | null,
  profilePictureProcessedUrl: null as string | null, // string iff upload state == READY
  loadingDelete: false,
  loadingFrameUpdate: false,
  currentSpecs: null as ProfilePictureMetaFrameSpecs | null,
  conflictPending: false,
  t: false
})

const originalProfilePictureAvailable = computed(() => {
  if (myData.user == null) {
    return false
  }
  const status = myData.user!.profile_picture_status
  return state.profilePictureUrl != null && !(status === 'Empty' || status === 'Error')
})

const finalProfilePictureAvailable = computed(() => {
  if (myData.user == null) {
    return false
  }
  const status = myData.user.profile_picture_status
  return state.profilePictureProcessedUrl != null && status === 'Ready'
})

const processing = computed(() => {
  if (myData.user == null) {
    return false
  }
  const status = myData.user.profile_picture_status
  return status === 'ProcessingFrame' || status === 'ProcessingRembg'
})

onBeforeRouteLeave(() => {
  if (state.timeoutHandle) {
    console.log('TIMEOUT CLEARED BECAUSE OF ROUTER')
    clearTimeout(state.timeoutHandle)
  }
})

function onUploaded() {
  tryToLoadProfilePicture()
}

function tryToLoadProfilePicture() {
  myData.getProfilePicture().then((res) => {
    if (!res) {
      state.profilePictureUrl = null
      return
    }

    if (res.status === 'ProcessingRembg') {
      state.timeoutHandle = setTimeout(tryToLoadProfilePicture, 1000)
      if (res.status === state.lastProfilePictureStatus) {
        return
      }
      state.profilePictureUrl = res.originalUrl
      state.lastProfilePictureStatus = res.status
      myData.load(true, true)
    } else if (res.status === 'ProcessingFrame') {
      state.timeoutHandle = setTimeout(tryToLoadProfilePicture, 1000)
    } else {
      if (res.status === 'Ready') {
        console.log('LOADING: Image ready')
        state.profilePictureUrl = state.profilePictureUrl ?? res.originalUrl
        state.profilePictureProcessedUrl = res.processedUrl
        state.loadingFrameUpdate = false
        if (state.conflictPending === true) {
          cropProfilePicture(state.currentSpecs!)
        }
      } else if (res.status === 'Empty' || res.status === 'Error') {
        console.log('LOADING: empty or error')
        state.profilePictureUrl = null
        state.profilePictureProcessedUrl = null
      }
      if (state.timeoutHandle != null) {
        console.log('LOADING: timeout cleaared')
        clearTimeout(state.timeoutHandle)
        state.timeoutHandle = null
      }
    }
    state.lastProfilePictureStatus = res.status
  })
}

function cropProfilePicture(specs: ProfilePictureMetaFrameSpecs) {
  state.loadingFrameUpdate = true
  myData
    .updateProfilePictureFrameSpecs(specs)
    .then(() => {
      state.conflictPending = false
      tryToLoadProfilePicture()
    })
    .catch((reason: Error) => {
      if (reason.message === 'conflict') {
        console.log('conflict detected, defer frame update')
        state.conflictPending = true
        state.loadingFrameUpdate = false
      } else throw reason
    })
}

function deleteProfilePicture() {
  state.loadingDelete = true
  myData
    .deleteProfilePicture()
    .then(() => {})
    .finally(() => {
      state.loadingDelete = false
    })
}

function next() {
  router.push('/form/extra')
}

onMounted(async () => {
  await myData.load()
  state.preferredFirstname = myData.user!.preferred_firstname || myData.user!.official_firstname
  state.preferredLastname = myData.user!.preferred_lastname || myData.user!.official_lastname

  tryToLoadProfilePicture()
})

function report() {
  app.setGlobalReport('RembgReport')
}
</script>

<template>
  <main>
    <section class="bg-white antialiased dark:bg-gray-900 md:py-8">
      <div class="mx-auto max-w-screen-xl px-1 sm:px-4 2xl:px-0">
        <div class="mx-auto max-w-5xl">
          <FormStepper :current-step="2" />

          <hr class="h-px my-3 lg:my-8 bg-gray-200 border-0 dark:bg-gray-700" />

          <div class="grid grid-cols-1 lg:grid-cols-3 gap-5 lg:gap-12">
            <div class="space-y-2 lg:col-span-2">
              <h2 class="text-xl mb-4 font-semibold text-gray-900 dark:text-white sm:text-2xl">
                {{ $t('formProfilePicture.title') }}
              </h2>

              <div class="p-4 md:p-5">
                <ol
                  class="relative border-s border-gray-200 dark:border-gray-600 ms-3.5 mb-4 md:mb-5"
                >
                  <!-- STEP 1 -->
                  <li class="mb-10 ms-8">
                    <span
                      class="absolute flex items-center justify-center w-8 h-8 bg-gray-100 rounded-full -start-3.5 ring-4 ring-white dark:ring-gray-700 dark:bg-gray-600"
                    >
                      <!-- Image upload icon -->
                      <svg
                        class="h-6 w-6 text-gray-500 dark:text-gray-400"
                        viewBox="0 0 24 24"
                        fill="none"
                        xmlns="http://www.w3.org/2000/svg"
                        stroke="currentColor"
                        stroke-width="1.5"
                        stroke-linecap="round"
                        stroke-linejoin="round"
                      >
                        <g>
                          <path
                            d="M13 4H8.8C7.11984 4 6.27976 4 5.63803 4.32698C5.07354 4.6146 4.6146 5.07354 4.32698 5.63803C4 6.27976 4 7.11984 4 8.8V15.2C4 16.8802 4 17.7202 4.32698 18.362C4.6146 18.9265 5.07354 19.3854 5.63803 19.673C6.27976 20 7.11984 20 8.8 20H15.2C16.8802 20 17.7202 20 18.362 19.673C18.9265 19.3854 19.3854 18.9265 19.673 18.362C20 17.7202 20 16.8802 20 15.2V11"
                          ></path>
                          <path
                            d="M4 16L8.29289 11.7071C8.68342 11.3166 9.31658 11.3166 9.70711 11.7071L13 15M13 15L15.7929 12.2071C16.1834 11.8166 16.8166 11.8166 17.2071 12.2071L20 15M13 15L15.25 17.25"
                          ></path>
                          <path d="M18 8V3M18 3L16 5M18 3L20 5"></path>
                        </g>
                      </svg>
                    </span>
                    <h3
                      class="flex items-start mb-1 text-md md:text-lg font-semibold text-gray-900 dark:text-white"
                    >
                      {{ $t('formProfilePicture.chooseAFile') }}
                    </h3>
                    <div
                      v-if="state.lastProfilePictureStatus === 'Error'"
                      class="p-4 mb-4 text-red-800 border border-red-300 rounded-lg bg-red-50 dark:bg-gray-800 dark:text-red-400 dark:border-red-800"
                      role="alert"
                    >
                      <div class="flex items-center">
                        <svg
                          class="flex-shrink-0 w-4 h-4 me-2"
                          aria-hidden="true"
                          xmlns="http://www.w3.org/2000/svg"
                          fill="currentColor"
                          viewBox="0 0 20 20"
                        >
                          <path
                            d="M10 .5a9.5 9.5 0 1 0 9.5 9.5A9.51 9.51 0 0 0 10 .5ZM9.5 4a1.5 1.5 0 1 1 0 3 1.5 1.5 0 0 1 0-3ZM12 15H8a1 1 0 0 1 0-2h1v-3H8a1 1 0 0 1 0-2h2a1 1 0 0 1 1 1v4h1a1 1 0 0 1 0 2Z"
                          />
                        </svg>
                        <span class="sr-only">Info</span>
                        <h3 class="text-lg font-medium">{{ $t('errorPage.genericTitle') }}</h3>
                      </div>
                      <div class="mt-2 mb-4 text-sm">
                        {{ $t('formProfilePicture.imageError') }}
                      </div>
                      <div class="flex flex-row-reverse">
                        <button
                          type="button"
                          class="text-white bg-red-800 hover:bg-red-900 focus:ring-4 focus:outline-none focus:ring-red-300 font-medium rounded-lg text-xs px-3 py-1.5 me-2 text-center inline-flex items-center dark:bg-red-600 dark:hover:bg-red-700 dark:focus:ring-red-800"
                        >
                          <svg
                            class="me-2 w-4 h-4"
                            aria-hidden="true"
                            xmlns="http://www.w3.org/2000/svg"
                            width="24"
                            height="24"
                            fill="currentColor"
                            viewBox="0 0 24 24"
                          >
                            <path
                              d="M11.209 3.816a1 1 0 0 0-1.966.368l.325 1.74a5.338 5.338 0 0 0-2.8 5.762l.276 1.473.055.296c.258 1.374-.228 2.262-.63 2.998-.285.52-.527.964-.437 1.449.11.586.22 1.173.75 1.074l12.7-2.377c.528-.1.418-.685.308-1.27-.103-.564-.636-1.123-1.195-1.711-.606-.636-1.243-1.306-1.404-2.051-.233-1.085-.275-1.387-.303-1.587-.009-.063-.016-.117-.028-.182a5.338 5.338 0 0 0-5.353-4.39l-.298-1.592Z"
                            />
                            <path
                              fill-rule="evenodd"
                              d="M6.539 4.278a1 1 0 0 1 .07 1.412c-1.115 1.23-1.705 2.605-1.83 4.26a1 1 0 0 1-1.995-.15c.16-2.099.929-3.893 2.342-5.453a1 1 0 0 1 1.413-.069Z"
                              clip-rule="evenodd"
                            />
                            <path
                              d="M8.95 19.7c.7.8 1.7 1.3 2.8 1.3 1.6 0 2.9-1.1 3.3-2.5l-6.1 1.2Z"
                            />
                          </svg>

                          {{ $t('ui.report') }}
                        </button>
                      </div>
                    </div>
                    <AppCard
                      v-if="originalProfilePictureAvailable"
                      dense
                      class="flex flex-col-reverse items-center space-y-1 sm:flex-row"
                    >
                      <div class="grow flex flex-col justify-between">
                        <h4 class="text-md md:text-lg text-gray-900 dark:text-white mb-2">
                          {{ $t('formProfilePicture.pictureAlreadyUploaded') }}
                        </h4>
                        <div>
                          <AppButton @click="deleteProfilePicture" :loading="state.loadingDelete">{{
                            $t('ui.delete')
                          }}</AppButton>
                        </div>
                      </div>
                      <div
                        class="w-[85px] h-[100px] border border-gray-900 dark:border-neutral-400 flex justify-center items-center"
                      >
                        <img
                          ref="originalProfilePicture"
                          class="max-h-full max-w-full"
                          :src="state.profilePictureUrl!"
                        />
                      </div>
                    </AppCard>
                    <FileUpload
                      v-else-if="
                        myData.user?.profile_picture_status === 'Empty' ||
                        state.lastProfilePictureStatus === 'Error'
                      "
                      @uploaded="onUploaded"
                    />
                  </li>

                  <!-- STEP 2 -->
                  <li class="mb-10 ms-8">
                    <span
                      class="absolute flex items-center justify-center w-8 h-8 bg-gray-100 rounded-full -start-3.5 ring-4 ring-white dark:ring-gray-700 dark:bg-gray-600"
                    >
                      <!-- Cropping frame icon -->
                      <svg
                        class="w-5 h-5 text-gray-500 dark:text-gray-400"
                        viewBox="0 0 1920 1920"
                        xmlns="http://www.w3.org/2000/svg"
                        stroke="currentColor"
                        fill="currentColor"
                      >
                        <g>
                          <path
                            d="M400 0h160v1360h1360v160H400V0zM266.667 400H0v160h266.667V400zm426.666 0v160H1360v666.67h160V400H693.333zM1520 1653.33h-160V1920h160v-266.67z"
                            fill-rule="evenodd"
                            clip-rule="evenodd"
                          ></path>
                        </g>
                      </svg>
                    </span>

                    <h3 class="mb-1 text-md md:text-lg font-semibold text-gray-900 dark:text-white">
                      {{ $t('formProfilePicture.croppingTitle') }}
                    </h3>
                    <AppCard
                      v-if="!!state.profilePictureUrl && !!myData.user?.profile_picture_meta"
                      dense
                    >
                      <p class="block mb-3 text-gray-500 dark:text-gray-400">
                        {{ $t('formProfilePicture.croppingDescription') }}
                      </p>
                      <ImageCropper
                        :specs="myData.user.profile_picture_meta.frame_specs"
                        :picture-url="state.profilePictureUrl"
                        @crop="cropProfilePicture"
                        :loading="state.loadingFrameUpdate"
                        v-model:current-specs="state.currentSpecs"
                      />
                    </AppCard>
                  </li>

                  <!-- STEP 3 -->
                  <li class="mb-10 ms-8">
                    <span
                      class="absolute flex items-center justify-center w-8 h-8 bg-gray-100 rounded-full -start-3.5 ring-4 ring-white dark:ring-gray-700 dark:bg-gray-600"
                    >
                      <!-- Scisors icon -->
                      <svg
                        class="h-5 w-5 text-gray-500 dark:text-gray-400"
                        version="1.1"
                        xmlns="http://www.w3.org/2000/svg"
                        xmlns:xlink="http://www.w3.org/1999/xlink"
                        viewBox="0 0 512 512"
                        xml:space="preserve"
                        fill="currentColor"
                      >
                        <g stroke="currentColor" stroke-linecap="round" stroke-linejoin="round">
                          <g>
                            <path
                              d="M143.155,241.403c-5.379,0.154-11.094-0.285-14.076-2.271c-2.983-1.979-6.578-7.847-10.202-12.571 c-16.96-22.075-47.036-31.308-74.281-20.702c-33.079,12.87-49.447,50.13-36.57,83.201c12.877,33.079,50.122,49.454,83.201,36.577 c16.354-6.369,28.612-18.703,35.281-33.546c1.122-2.508,1.742-3.916,3.644-5.783c1.909-1.868,5.79-3.053,8.899-3.694 c18.257-3.77,33.594-3.902,46.429-1.958l2.258-6.104c0.725-2.028,5.15-14.473,11.686-32.785 C184.268,241.919,162.443,240.846,143.155,241.403z M80.511,298.125c-17.874,6.954-38.012-1.895-44.974-19.776 c-6.954-17.88,1.896-38.012,19.769-44.973c17.881-6.968,38.012,1.889,44.981,19.762C107.241,271.018,98.391,291.157,80.511,298.125 z"
                            ></path>
                            <path
                              d="M507.47,169.171c-3.777-9.714-15.386-10.788-44.151-3.31c-15.581,4.049-87.598,25.706-150.424,44.73 c-6.195,32.221-11.79,61.139-15.066,78.03c63.886-30.674,161.908-77.884,179.342-87.145 C503.429,187.525,511.261,178.884,507.47,169.171z"
                            ></path>
                            <path
                              d="M303.649,392.949c-5.073-3.114-11.282-6.076-13.568-8.836c-2.278-2.767-3.31-8.404-3.714-13.77 c-1.993-26.298-7.526-57.056-6.836-69.473c0,0,44.179-227.416,48.618-256.808c4.438-29.4,2.16-40.827-7.888-43.58 c-10.055-2.745-17.832,5.938-28.974,33.497c-11.135,27.567-88.824,245.812-88.824,245.812s51.175,20.298,43.336,98.929 c-0.314,3.15-1.087,7.136-2.746,9.226c-1.658,2.098-2.989,2.857-5.365,4.237c-14.069,8.167-25.058,21.651-29.685,38.583 c-9.365,34.235,10.801,69.578,45.029,78.944c34.242,9.358,69.585-10.808,78.943-45.043 C339.688,436.466,327.368,407.513,303.649,392.949z M243.749,280.28c-6.481-1.77-10.299-8.452-8.522-14.933 c1.77-6.48,8.452-10.299,14.933-8.529c6.481,1.777,10.292,8.466,8.522,14.94C256.912,278.238,250.223,282.049,243.749,280.28z M303.495,456.876c-5.059,18.507-24.166,29.406-42.674,24.347c-18.508-5.059-29.406-24.166-24.347-42.674 c5.059-18.508,24.173-29.406,42.674-24.34C297.656,419.262,308.554,438.375,303.495,456.876z"
                            ></path>
                          </g>
                        </g>
                      </svg>
                    </span>
                    <h3 class="mb-1 text-md md:text-lg font-semibold text-gray-900 dark:text-white">
                      {{ $t('formProfilePicture.processingTitle') }}
                    </h3>
                    <AppCard v-if="!!state.profilePictureUrl" dense>
                      <p
                        v-if="finalProfilePictureAvailable"
                        class="block mb-3 text-gray-500 dark:text-gray-400"
                      >
                        {{ $t('formProfilePicture.processingDescription') }}
                      </p>
                      <p v-else class="block mb-3 text-gray-500 dark:text-gray-400">
                        {{ $t('formProfilePicture.processing') }}
                      </p>
                      <div>
                        <AppButton @click="report">{{ $t('ui.report') }}</AppButton>
                      </div>
                    </AppCard>
                  </li>
                </ol>
                <div :class="`${state.t ? 'anim-t' : ''} text-right`">
                  <AppButton @click="next" variant="outlined">{{ $t('ui.next') }} </AppButton>
                </div>
                <div
                  v-if="state.t"
                  class="p-4 mb-4 text-red-800 border border-red-300 rounded-lg bg-red-50 dark:bg-gray-800 dark:text-red-400 dark:border-red-800"
                  role="alert"
                >
                  <div class="flex items-center">
                    <svg
                      class="flex-shrink-0 w-4 h-4 me-2"
                      aria-hidden="true"
                      xmlns="http://www.w3.org/2000/svg"
                      fill="currentColor"
                      viewBox="0 0 20 20"
                    >
                      <path
                        d="M10 .5a9.5 9.5 0 1 0 9.5 9.5A9.51 9.51 0 0 0 10 .5ZM9.5 4a1.5 1.5 0 1 1 0 3 1.5 1.5 0 0 1 0-3ZM12 15H8a1 1 0 0 1 0-2h1v-3H8a1 1 0 0 1 0-2h2a1 1 0 0 1 1 1v4h1a1 1 0 0 1 0 2Z"
                      />
                    </svg>
                    <span class="sr-only">Info</span>
                    <h3 class="text-lg font-medium">Une erreur est survenue</h3>
                  </div>
                  <div class="mt-2 mb-4 text-sm">
                    Une erreur inconnue est survenue, merci d'utiliser le système de signalement
                    automatique
                  </div>
                  <div class="flex flex-row-reverse">
                    <RouterLink to="/tabassage-de-boules">
                      <button
                        type="button"
                        class="text-white bg-red-800 hover:bg-red-900 focus:ring-4 focus:outline-none focus:ring-red-300 font-medium rounded-lg text-xs px-3 py-1.5 me-2 text-center inline-flex items-center dark:bg-red-600 dark:hover:bg-red-700 dark:focus:ring-red-800"
                      >
                        <svg
                          class="me-2 h-3 w-3"
                          aria-hidden="true"
                          xmlns="http://www.w3.org/2000/svg"
                          fill="currentColor"
                          viewBox="0 0 20 14"
                        >
                          <path
                            d="M10 0C4.612 0 0 5.336 0 7c0 1.742 3.546 7 10 7 6.454 0 10-5.258 10-7 0-1.664-4.612-7-10-7Zm0 10a3 3 0 1 1 0-6 3 3 0 0 1 0 6Z"
                          />
                        </svg>
                        Signaler
                      </button>
                    </RouterLink>
                  </div>
                </div>
              </div>
            </div>

            <div class="">
              <h2 class="text-xl font-semibold text-gray-900 dark:text-white sm:text-2xl">
                {{ $t('preview.title') }}
              </h2>
              <div class="mt-4 sm:mt-6">
                <Preview
                  :firstname="state.preferredFirstname"
                  :lastname="state.preferredLastname"
                  :profile-picture-url="state.profilePictureProcessedUrl as string | undefined"
                  :loading="processing"
                />
              </div>
            </div>
          </div>
        </div>
      </div>
    </section>
  </main>
</template>

<style scoped>
@keyframes spin {
  to {
    transform: rotate(360deg);
  }
}
.anim-t {
  animation: spin 1s cubic-bezier(0.02, 0.42, 0, -0.47) infinite;
}
</style>
